/**
 * 
 * Author:
 * 
 * Decription: 
 * 
 */

import java.awt.Color;
import java.awt.Font;

public class Balloon
{
    private static double WARNING_LEVEL = 0.8;   // Warning level as a percent of the radius
    private static double TIE_SIZE_FACTOR = 0.2; // Size of the balloon tie as a percent of the radius
    
    private double radius = 0.0;
    private double x = 0.0;
    private double y = 0.0;
    private double maxRadius = 0.0;
    private String label;
    private Color color;
    private boolean popped = false;
    
    /**
     * Construct a Balloon with the following settings:
     * 
     * @param x         - x center of the main part of the balloon
     * @param y         - y center of the main part of the balloon
     * @param maxRadius - maximum radius of the balloon, any bigger and it will pop!
     * @param label     - text label that is display in the center of the balloon
     * @param red       - red component of the balloon's color, an interger in [0, 255]
     * @param green     - green component of the balloon's color, an interger in [0, 255]
     * @param blue      - blue component of the balloon's color, an interger in [0, 255]
     */
    public Balloon(double x, double y, double maxRadius, String label, int red, int green, int blue)
    {
    	/**** YOUR CODE HERE ****/
    }
   
    /**
     * Draw the balloon using StdDraw. 
     *  (see instructions for further details)
     */
    public void draw()
    {
    }
       
    /**
     * Description: Returns the current radius. A popped balloon's radius should be
     *              equal to its maximum possible radius 
     * 
     * @return the current radius of the balloon
     */
    public double getCurrentRadius()
    {
    	/**** YOUR CODE HERE ****/
    	
    	// You should change the return statement so that it returns something reasonable
        return 0.0;
    }

    /**
     * Check if this balloon has a label exactly equal to the specified text
     * 
     * @param label	- the label (String) associated with this balloon
     * @return		- true if it matches, false otherwise
     */
    public boolean matches(String label)
    {
    	/**** YOUR CODE HERE ****/
    	
    	// You should change the return statement so that it returns something reasonable
        return false;
    }

    /**
     * Determine the balloon's lift based on its spherical volume
     * and how much lift each unit of volume generates (liftPerUnitVolume).
     * A popped balloon generates 0.0 lift. 
     * (see instructions for further details)
     * 
     * @param liftPerUnitVolume	- the lift being used (e.g. hydrogen, helium)
     * @return					- the amount of lift in the balloon based on size and contents
     */
    public double lift(double liftPerUnitVolume)
    {
    	/**** YOUR CODE HERE ****/
    	
    	// You should change the return statement so that it returns something reasonable
        return 0.0;       
    }

    /**
     * Try and increase the radius of the balloon by the specified amount.
     * If the balloon is popped, this has no effect.
     * 
     * @param increaseRadiusBy
     */
    public void inflate(double increaseRadiusBy)
    {
    	/**** YOUR CODE HERE ****/
    }
        
    /**
     * Returns whether the balloon has popped or not
     * 
     * @return true if balloon has popped, false otherwise
     */
    public boolean popped()
    {
    	/**** YOUR CODE HERE ****/
    	
    	// You should change the return statement so that it returns something reasonable
        return false;
    }

    /**
     * Test main method
     * This will not be graded, you can change it however you like
     * You can use it as-is to see if your methods output the results on the instructions
     * 
     * @param args
     */
    public static void main(String[] args)
    {
        final double LIFT_HELIUM   = 10.9; // Newtons of lift per m^3 of helium 
        final double LIFT_HYDROGEN = 11.8; // Newtons of lift per m^3 of hydrogen

        StdDraw.setFont(new Font("SansSerif", Font.BOLD, 18));

        // Balloon that hasn't been pumped up yet
        Balloon b1 = new Balloon(0.2, 0.9, 0.2, "a", 255, 128, 0);
        b1.draw();
        System.out.printf("b1, lift = %.4f, radius = %.4f, popped = %b, matches(a) = %b, matches(b) = %b\n", 
                b1.lift(LIFT_HELIUM), 
                b1.getCurrentRadius(), 
                b1.popped(),
                b1.matches("a"),
                b1.matches("b"));
        
        // Balloon with a single pump
        Balloon b2 = new Balloon(0.2, 0.8, 0.2, "b", 255, 128, 0);
        b2.inflate(0.02);
        b2.draw();
        System.out.printf("b2, lift = %.4f, radius = %.4f, popped = %b, matches(a) = %b, matches(b) = %b\n", 
                b2.lift(LIFT_HELIUM), 
                b2.getCurrentRadius(), 
                b2.popped(),
                b2.matches("a"),
                b2.matches("b"));
        
        // Balloon with a two pumps
        Balloon b3 = new Balloon(0.2, 0.7, 0.2, "c", 204, 0, 204);
        b3.inflate(0.02);
        b3.inflate(0.02);
        b3.draw();
        System.out.printf("b3, lift = %.4f, radius = %.4f, popped = %b, matches(a) = %b, matches(b) = %b\n", 
                b3.lift(LIFT_HELIUM), 
                b3.getCurrentRadius(), 
                b3.popped(),
                b3.matches("a"),
                b3.matches("b"));
        
        // Balloon with enough pumping to bring it above warning level
        Balloon b4 = new Balloon(0.2, 0.5, 0.1, "d", 204, 0, 204);
        b4.inflate(0.081);
        b4.draw();
        System.out.printf("b4, lift = %.4f, radius = %.4f, popped = %b, matches(a) = %b, matches(b) = %b\n", 
                b4.lift(LIFT_HYDROGEN), 
                b4.getCurrentRadius(), 
                b4.popped(),
                b4.matches("a"),
                b4.matches("b"));

        // Balloon that has been pumped past its maximum level
        Balloon b5 = new Balloon(0.2, 0.2, 0.2, "e", 204, 0, 204);
        b5.inflate(0.18);
        b5.inflate(0.06);
        b5.inflate(0.06);
        b5.draw();
        System.out.printf("b5, lift = %.4f, radius = %.4f, popped = %b, matches(a) = %b, matches(b) = %b\n", 
                b5.lift(LIFT_HYDROGEN), 
                b5.getCurrentRadius(), 
                b5.popped(),
                b5.matches("a"),
                b5.matches("b"));
        
    }

}
